/**********************************************************************
 * squishy_bugs.h                                          October 1999
 * Horms                                            horms@vergenet.net.
 * Verge Systems International                    http://vergenet.net./
 *
 * Squishy Bugs                                      
 * Squish the bugs with your mouse as they crawl up your terminal.
 * 
 * Written for Felicity <flea@flea.org>
 * Code hacked from slhelp.c, as distributed with slang
 * Released under the terms of the GNU GPL
 **********************************************************************/

#ifndef SQUISHY_BUGS
#define SQUISHY_BUGS


#define VERSION "0.0.0"
#define BUG '0'
#define DEADBUG '*'
#define NOBUG ' '
#define SQUISH_STRING "*squish*"
#define SQUISH_STRING_STAY 5

#include <slang/slang.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>


/**********************************************************************
 * SBtt_get_screen_size
 * Get the screen size, can be used as a signal handler for SIGWINCH
 * if it exists on the system
 *
 * Borrowed from slhelp.c
 **********************************************************************/

static void SBtt_get_screen_size (int sig) ;


/**********************************************************************
 * SBtt_cls
 * Clear the screen
 * 
 * Borrowed from slhelp.c
 **********************************************************************/

static void SBtt_cls (void) ;


/**********************************************************************
 * SB_new_bug
 **********************************************************************/

int SB_new_bug(char **bugs, int population, int density, int cells);


/**********************************************************************
 * SBtt_putchar_rc
 * Put a character in a row an column co-cordinate
 **********************************************************************/

void SBtt_putchar_rc(char ch, int r, int c);


/**********************************************************************
 * SBtt_putchar_cell
 * Put a character in a row an cell location
 **********************************************************************/

void SBtt_putchar_cell(char ch, int cell);


/**********************************************************************
 * SB_move_bug
 * Move a bug up the screen
 * Return: -1 if there is no bug in cell
 *         1  if the bug is moved off the screen
 *         0  if the bug is moved on the screen
 **********************************************************************/
  
int SB_move_bug(char **bugs, int cell);


/**********************************************************************
 * SB_put_bug_cell
 * Put a bug in a cell (or remove a bug from a cell)
 **********************************************************************/

void SB_put_bug_cell(char **bugs, char ch, int cell);


/**********************************************************************
 * SB_put_bug_rc
 * Put a bug in a row, column co-ordinate
 **********************************************************************/

void SB_put_bug_rc(char **bugs, char ch, int r, int c);

/**********************************************************************
 * SB_get_key
 * Non blocking get key implimented using SLang_input_pending
 * Argument as for SLang_input_pending
 * Return: 0 if no input ready
 *         input as per SLang_getkey, otherwise
 **********************************************************************/

int SB_get_key(int tsecs);


/**********************************************************************
 * SB_kill_bug_mouse
 * Kill a bug according to a mouse click
 * Return: 0 if no bugs killed
 *         number of bugs killed (1) otherwise
 **********************************************************************/

int SB_kill_bug_mouse(
  char **bugs, 
  int x, 
  int y, 
  int b, 
  int range,
  int cells
);

#endif
